// -------------------------------------------------------------------------

#IFNOT system_type ponto ;
public int text(char *txt,int max,int text_flags)
{
#IF compile_input_functions 1;
										#define			input_protected	-1
										#define			auto_exit_field	-2

										// template = -4 		-> hide password
										// template = -8 		-> input is a number
										// template = -16		-> Exit Read with Enter
										// template = -32		-> Exit Read Always
										// template = -64		-> Reserved Barcode
										// template = -128		-> NotUnderlined
										// template = -256		-> Use Link
										// template = -512 		-> Clear text
										// template = -1024		-> RightAligned
										// template = -2048		-> Dont ShowZero
										// template = -4096		-> ForceFunctionKeys
										// template = -8192		-> no function keys
										// template = -16384		-> Auto exit field ON - no ultimo caracter
										// template = -32768		-> Check Template, Only exit if template OK
										// template = -65536		-> . exits; O and k exit and inserts an Enter key
										// template = -131072	-> 1234567890+-*/
										// template = -262144	-> cursor at right
										// template = -524288	-> no horizontal scroll
										// template = -1048576	-> Reserved TagIt
										// template = -2097152	-> Reserved Barcode ( barcode don't accept text )
										// template = -4194304	-> Reserved Mandatory fields ( if activated Read exit when all fields are filled )
										// template = -8388608	-> Don't allow zero as input

										#define			floating_point_input	-16777216

	int p,b,line;
	public int x;
	public int n;
	int key,lastkey;
	int lcd_cursor,lcd_cursor_line,lcd_cursor_column;
	int keylistptr;
	int keytimer;
	int init_cursor_pos;
	char *template;
	char fkeylist[2][12][9]={
					131,':',',',';',133,':',',',';',0,
					0,0,0,0,0,0,0,0,0,
					'*','+','-','/','*','+','-','/',0,
					131,' ',' ',' ',133,' ',' ',' ',0,
					131,'a','b','c',133,'a','b','c',0,
					131,'d','e','f',133,'d','e','f',0,
					131,'g','h','i',133,'g','h','i',0,
					131,'j','k','l',133,'j','k','l',0,
					131,'m','n','o',133,'m','n','o',0,
					'p','q','r','s','p','q','r','s',0,
					131,'t','u','v',133,'t','u','v',0,
					'w','x','y','z','w','x','y','z',0,

					131,':',',',';',133,':',',',';',0,
					0,0,0,0,0,0,0,0,0,
					'*','+','-','/','*','+','-','/',0,
					131,'a','b','c',133,'a','b','c',0,
					131,'d','e','f',133,'d','e','f',0,
					131,'g','h','i',133,'g','h','i',0,
					131,'j','k','l',133,'j','k','l',0,
					131,'m','n','o',133,'m','n','o',0,
					131,'p','q','r',133,'p','q','r',0,
					131,'s','t','u',133,'s','t','u',0,
					131,'v','w','x',133,'v','w','x',0,
					131,'y','z',' ',133,'y','z',' ',0
				};
	sensech2();
#IF software_type  BATCH;
#IF tag_type TagIt novatronica Calypso Rfid125;
	if(strlen(global_input_buffer_func_getch)>0)
	{
		strcpy(txt,global_input_buffer_func_getch);
		getch();
		*global_input_buffer_func_getch=0;
		beep(200,200);
		return(0-13);
	}
#ENDIF ;
#ENDIF ;
	text_flags=0-text_flags;

	if( (alpha_mode&2) && (!(text_flags&8)) )
	{
		multitap_alpha=0;		// off
	}
	else
	{
		multitap_alpha=-1;		// off and disabled
	}

	set_text_cursor_height();
	if(max>512)
	{
		template=max;
		max=strlen(max);
	}
	else
	{
		template=0;
	}

	if(text_flags & 128)
	{
		space_in_text=' ';
	}
	else
	{
		space_in_text='_';	
	}

	if(text_flags & 512)
	{
		*txt=0;
	}

	txt[max]=0;
	cursor_width(1);
	x = ( init_cursor_pos = get_cursor() );
	if( template && *template=='~' && (*txt==0) )
	{
		print_string(template+1);
		cursor(x);
		update_screen();
		template=0;
	}
	if( template && (*txt==0) )
	{
		n=0;
		while( template[n] )
		{
			if( template[n]!='%' && template[n]!='@' && template[n]!='#' && template[n]!='?')
			{
				txt[n]=template[n];
			}
			else
			{
				if(template[n]=='#' )
				{
					txt[n]='0';
				}
				else
				{
					txt[n]=' ';
				}
			}
			n++;
		}
		txt[n]=0;
	}
	memset(read_cpu_register32(CPU_DX),space_in_text,max );
	if( text_flags&4 )
	{
		memset(read_cpu_register32(CPU_DX),'*',strlen(txt));
		update_screen();
	}
	else
	{
		if(text_flags & 1024)
		{
			cursor(init_cursor_pos+max-strlen(txt));						
			if(strcmp(txt,"0") || !(text_flags & 2048) )
			{
				print_string(txt);
			}
		}
		else
		{
			if(strcmp(txt,"0") || !(text_flags & 2048) )
			{
				print_string(txt);
			}
			cursor(x);
		}
	}


// --------------------- Process the initial key ---------------------------

	if(drawing_form)
	{
		return(0);
	}
	
	n=0;
	
	if(text_flags&262144)
	{
		key=END;
		sensech2();
	}
	else
	{	
		if(hardware_is_pricechecker)			// PriceChecker
		{
			key=RIGHT;
		}
		else
		{
			key=sensech();
		}
	}

	switch(key)
	{
		case DOWN:
		case UP:
		case 27:
				getch();
				break;

		case ENTER:
//				getch();
//				return(TAB);
		case RIGHT:

				if(!hardware_is_pricechecker)			// PriceChecker
				{
					getch();
				}



#IF tag_type Calypso ;	
int size;
int rfid_result;
char auxstring[11];
char temp_string2[11];
int serial;
				if(text_flags & 1048576)
				{
					do
					{
						
					}while(inkey()!=0);
					
					do
					{
						memset(temp_string2,0,10);	
						rfid_result=read_rfid_serial_ISO_14443B(&serial);
					}
					while(inkey()!=0 && rfid_result==0 );

					if(rfid_result)
					{
						itoa(serial,txt,10);
						print_string(txt);
						keyboard_unread_from_buffer(13,0);
						beep(100,100);
						break;
					}
				}
#ENDIF ;

#IF tag_type Rfid125 ;	
int size;
int rfid_result;
char auxstring[21];
char temp_string2[21];
				if(text_flags & 1048576)
				{
/*				
					do
					{
						
					}while(inkey()!=0);
*/										
					memset(temp_string2,0,10);	
					rfid_result=read_rfid_serial_always(temp_string2);

					if(rfid_result)
					{
						strcpy(txt,temp_string2);
						print_string(txt);
						keyboard_unread_from_buffer(13,0);
						beep(100,100);
						break;
					}
				}
#ENDIF ;

#IF tag_type TagIt ;	
int size;
char temp_string2[21];
				if(text_flags & 1048576)
				{

					do
					{					
					}
					while(inkey()>0 );

					memset(temp_string2,0,20);
					if(read_rfid_serial_always(temp_string2))
					{		
						strcpy(txt,temp_string2);
						print_string(txt);
						keyboard_unread_from_buffer(13,0);
						beep(100,100);
						break;
					}

				}
#ENDIF ;

				lcd_cursor=read_cpu_register32(CPU_DX)-display_ram-display_address_func_set_display;
				lcd_cursor_column=lcd_cursor%display_width;
				lcd_cursor_line=read_cpu_register32(CPU_REG4);
				n=strlen(txt);
				if( (n+lcd_cursor_column)>=lcd_width )
				{
					n=lcd_width-lcd_cursor_column;
				}
				x+=n;
				cursor(x);
				if(txt[n])
				{
					putch(txt[n]);
				}
				break;
		case 8:
		case LEFT:
				getch();
		case END:
				n=strlen(txt);
				x+=n;
				cursor(x);
				if(txt[n])
				{
					putch(txt[n]);
				}
				break;
		

		default:
				if(*txt && !template)
				{
					if( ( key>='0' && key<='z' ) || key=='.' ) 
					{
						*txt=0;	
						memset(display_ram+x,space_in_text,max);
						n=0;				
					}
				}
	}



	lastkey=0;
	if( !(text_flags & 256))
	{
		set_display(display_address_func_set_display);
	}

// IF string is a number
// set function keys to *+-/
	if( !(text_flags&256) && !(text_flags&4096) && !(text_flags&8192) )
	{
		if( text_flags & 131080 )
		{
#IF multi_display_modes 1 ;
			if(!(alpha_mode&2))
			{
#IF software_client DIA ;
				char auxfk[19];
				memset(auxfk,' ',18);
				auxfk[2]='+';
				auxfk[5]='+';
				auxfk[8]='*';
				auxfk[11]='*';
				auxfk[12]='E';
				auxfk[13]='n';
				auxfk[14]='t';
				auxfk[15]='e';
				auxfk[16]='r';
				auxfk[17]=13;
				auxfk[18]=0;
				set_function_keys(auxfk,6);
#ELSE ;
				set_function_keys(fkeylist[alpha_mode&1][2],1);
#ENDIF ;
			}
#ELSE ;
			set_function_keys(fkeylist[alpha_mode&1][2],1);
#ENDIF ;
		}
	}

//								Main edit loop

	int back_getch_waits_for_serie;
	back_getch_waits_for_serie=getch_waits_for_serie;
	getch_waits_for_serie=0;


	do
	{
		sensech2();

		if(!(text_flags&1024))
		{
			cursor(x);
			lcd_cursor=read_cpu_register32(CPU_DX)-display_ram-display_address_func_set_display;
			lcd_cursor_column=lcd_cursor%display_width;
			lcd_cursor_line=read_cpu_register32(CPU_REG4);
	
			if( lcd_cursor_line<LCDLINES && lcd_cursor_column>=(lcd_width-1) )
			{
				if((text_flags&524288)==0)
				{

					p=0;
					b=1;
					line=0;
					while(line<lcd_cursor_line)
					{
						if(b&screen_format)
						{
							p++;
						}
						line++;
						p++;
						b=b*2;
					}
					sensech2();
					if(b&screen_format)
					{
						write_cpu_register32(CPU_SCREENLINE1+4*(p+title_lines+debug_lines),read_cpu_register32(CPU_DX)-(lcd_width-1)+64*256*256*256);
						write_cpu_register32(CPU_SCREENLINE2+4*(p+title_lines+debug_lines),read_cpu_register32(CPU_DX)-(lcd_width-1)+(128+64)*256*256*256);
					}
					else
					{
						write_cpu_register32(CPU_SCREENLINE1+4*(p+title_lines+debug_lines),read_cpu_register32(CPU_DX)-(lcd_width-1));
					}
					update_screen();
				}
			}
		}

		if( template && template[n]!='%' && template[n]!='@' && template[n]!='?' && template[n]!='#' && template[n] )
		{
			if ( n && ( lastkey==LEFT || lastkey==8 ) )
			{
				key=LEFT;
			}
			else
			{
				key=RIGHT;
			}
			sensech2();
		}
		else
		{
			update_screen();
			key=getch();
		}

		if(text_flags & 1 )
		{
			if(key==8 || ( key>='0' && key<='z') )
			{
				key=0;
			}	
		}
		lastkey=key;

#IF system_type vertical ;
// IF a keypad key
		if( internal_func_translate_scancode )
		{
			if( !(text_flags&8192) )
			{
#IF gsm_alpha 0 ;
				if(!(text_flags&256) && !(text_flags&4096)) 
				{
					if( (text_flags&131080)==0 )
					{
// IF key is a digit
// set function keys chars
						if( isdigit(key7_func_translate_scancode) || key7_func_translate_scancode=='.' )
						{
#IF multi_display_modes 1 ;
							if(!(alpha_mode&2))
							{
								set_function_keys(fkeylist[alpha_mode&1][key7_func_translate_scancode-'.'],1);
							}
#ELSE ;
							set_function_keys(fkeylist[alpha_mode&1][key7_func_translate_scancode-'.'],1);
#ENDIF ;
							if(caps_lock)
							{
								update_function_key_caps();
							}
						}
// or reset them to default values
						else
						{
#IF multi_display_modes 1 ;
							if(!(alpha_mode&2))
							{
								set_function_keys(fkeylist[alpha_mode&1][0],1);
							}
#ELSE ;
							set_function_keys(fkeylist[alpha_mode&1][0],1);
#ENDIF ;
						}
					}
				}
#ENDIF ;
				
// IF string is numeric AND +-*/ was pressed
#IFNOT easy_conf 0 ;
// call the calculator
				if( inside_os_menu==0 && ( text_flags & 8 ) && ( key=='+' || (key=='-'&&(*txt)) || key=='*' || key=='/' ) )
				{
					inside_os_menu++;
					if( *txt )
					{
						keyboard_unread_from_buffer(key,0);
#IF calculator_floats 1 ;
						result_func_calculator=atof(txt);
#ELSE ;
						result_func_calculator=atoi(txt);
#ENDIF ;
						operator_func_calculator='=';
					}
					else
					{
						operator_func_calculator=0;
					}


//					if(type_func_calculator==0)
//					{
//#IFGREATEROREQUAL system_version 700 ;
//						type_func_calculator=7;
//#ELSE ;
//						type_func_calculator=5;
//#ENDIF ;
//					}
//					os_menu(type_func_calculator);





					cursor(init_cursor_pos);
					calculator(10);

#IF calculator_floats 1 ;
					if(text_flags&16777216)
					{
						ftoa( result_func_calculator, buffer_func_calculator, decimal_points );
					}
					else
					{
						while(result_func_calculator.e>0)
						{
							result_func_calculator.e--;
							result_func_calculator.a=result_func_calculator.a/10;
						}
						itoa( result_func_calculator.a, buffer_func_calculator, 0 );
					}
#ELSE ;
					itoa( result_func_calculator, buffer_func_calculator, 10 );
#ENDIF ;
					if( strlen(buffer_func_calculator) <= max )
					{
						strcpy(txt,buffer_func_calculator);
						memset(display_ram+init_cursor_pos,space_in_text,max);
						if(!(text_flags&1024))
						{
							memcpy(display_ram+init_cursor_pos,txt,strlen(txt));
						}
						x=x-n+strlen(txt);
						n=strlen(txt);
					}
					key=13;
					inside_os_menu--;






/*
					if( *key_func_calculator=='=' )
					{
						itoa( result_func_calculator, buffer_func_calculator, 10 );
						if( strlen(buffer_func_calculator) <= max )
						{
							strcpy(txt,buffer_func_calculator);
							memset(display_ram+init_cursor_pos,space_in_text,max);
							if(!(text_flags&1024))
							{
								memcpy(display_ram+init_cursor_pos,txt,strlen(txt));
							}
							x=x-n+strlen(txt);
							n=strlen(txt);
						}
					}
					key=0;
					inside_os_menu--;
*/





				}
#ENDIF ;
			}
		}
// IF not a keypad key
		else
		{
			if ( n==0 )
			{
				barcode_beep();
			}
		}
#ENDIF ;
		if(text_flags&65536)
		{
			if(key=='.')
			{
				break;
			}
			if( fkey_func_keyboard_beep )
			{
				if( key=='O'  )
				{
					keyboard_unread_from_buffer(13,0);
				}
				key=13;
			}
		}

		switch(key)			/* Process control keys */
		{
			case LEFT:
						if(!(text_flags&1024))
						{
							if(n)
							{
								n--;
								x--;
								cursor(x);
								if(txt[n])
								{
									if( text_flags&4 )
									{
										putch('*');
									}
									else
									{
										putch(txt[n]);
									}
								}
							}
						}
						key=0;
						break;
			case 8:
						if(n)
						{
							if( template && template[n-1]!='%' && template[n-1]!='@' && template[n-1]!='#' && template[n-1]!='?' && template[n-1] )
							{
								break;
							}
							x--;
							n--;
							
							strcpy(txt+n,txt+n+1);
							cursor(init_cursor_pos);
							if( text_flags&4 )
							{
								memset(print_ram+init_cursor_pos,'*',strlen(txt));
							}
							else
							{
								strcpy(print_ram+init_cursor_pos,txt);
							}
							memset(print_ram+init_cursor_pos+strlen(txt),space_in_text,1);
							cursor(x);
						}
						key=0;
						break;


#IF software_type XRML2 XRML1 ;

#IF system_type horizontal rio ;
			case '.':
#ENDIF ;

#IF system_type vertical ;
			case '?':
#ENDIF ;

				if(text_flags&256)
				{
					SystemLinkScreenNumber=get_link();
					system_exit_read_type=1;
					system_text_value=atoi(txt);
					key=-27;
				}
				break;
#ENDIF;
			case 13:
											// No aceita 0 como input se o template for '0000'
				if(text_flags&8388608)
				{
					if(atoi(txt)==0)
					{
						key=0;
						break;
					}
				}			
			
				if(text_flags&16)
				{
					//key=-27;
					key=-26;					// changed on 4/7/2003 (bolsa)
					break;					
				}
				else
				{
					key=-TAB;
					break;
				}	

			case '.':
				if(text_flags&8)
				{
					if( !(text_flags&floating_point_input) )
					{
						key=0-27;
					}
					else
					{
						if( strchr(txt,'.') )
						{
							key=0;
						}
					}
				}				
				break;


			case SHIFT_DOWN:
			case SHIFT_UP:
			case DOWN:
			case UP:
			case 27:
				if(text_flags&32)
				{
					key=27;
				}
				key=0-key;
				break;
			case RIGHT:
				if( n<max && txt[n]!=0 )
				{
					if(txt[n])
					{
						if( text_flags&4 )
						{
							putch('*');
						}
						else
						{
							putch(txt[n]);
						}
					}
					n++;
					x++;
				}
				key=0;
				break;
			default:
// Exit input if the user press a function key
/*
				if(text_flags & 4096)
				{
					if( fkey_func_keyboard_beep && fkey_func_keyboard_beep<=enabled_function_keys )
					{
						system_text_value=key;
						key=-27;
						break;
					}	
				}
*/				
				
				if( ( text_flags & 8 ) || ( template && template[n]=='#' ) )
				{
					if( !isdigit(key) && key!='.' && key!=' ' && key!='-' )
					{
						key=0;
					}
				}

				if( ( template && template[n]=='%' ) )
				{
					if( !isalpha(key) )
					{
						key=0;
					}
				}
		}

// IF a key is still to be processed
		if( key > 0 )
		{
// IF a function key was pressed AND cursor is after first char AND char to the left is a digit
// char to the left is to be replaced

#IF system_type vertical ;
			if( (text_flags&131072)==0 && fkey_func_keyboard_beep && n && ( ( isdigit(txt[n-1]) || txt[n-1]=='.' ) || (alpha_mode&2)) )
			{
				n--;
				x--;
				cursor(get_cursor()-1);
			}
#ENDIF ;
			
// IF string is not complete
// write the char and advance pointers
			if(n<max)
			{
				if(txt[n]==0)
				{
					txt[n+1]=0;
				}
				txt[n]=key;
				n++;
				x++;
				
				if( text_flags&4 )
				{
					putch('*');
				}
				else
				{
					if(!(text_flags&1024))
					{
						putch(key);
					}
				}
				if(n==max)
				{
					if(text_flags & 16384)
					{
						key= -13;
						if(text_flags&32)
						{
							key=-27;
						}
						break;
					}
				}
			}
			else
			{
				if(text_flags & 2)
				{
					ungetch();
					key= -DOWN;
					if(text_flags&32)
					{
						key=-27;
					}
					break;
				}
			}
		}

		if( text_flags & 1024)
		{
			memset(display_ram+init_cursor_pos,space_in_text,max);
			cursor(init_cursor_pos+max-strlen(txt));					
			print_string(txt);
			x=init_cursor_pos+max+n-strlen(txt);
		}

	}
	while(key>=0);
	cursor(x-n);
	if(!(text_flags&8192))
	{
		set_function_keys("",1);
	}
	if( !(text_flags & 256))
	{
		set_display(display_address_func_set_display);
	}
	getch_waits_for_serie=back_getch_waits_for_serie;
	return(0-key);
#ENDIF ;
}

#ELSE ;
text(char *txt,int max,int text_flags)
{
										// template = -1		-> Input Protected
										// template = -2 		-> Auto exit field ON
										// template = -4 		-> hide password
										// template = -1048576	-> Reserved TagSys

	int x,key,lastkey,n;
	int lcd_cursor,lcd_cursor_line,lcd_cursor_column;
	
	int keylistptr;
	int keytimer;
	int init_cursor_pos;
	char *template;

	int p,v,line;

	char keylist[12][5]={
					':',',',';',0,0,
					0,0,0,0,0,
					'*','+','-','/',0,
					'S','T','U',0,0,
					'V','W','X',0,0,
					'Y','Z',' ',0,0,
					'J','K','L',0,0,
					'M','N','O',0,0,
					'P','Q','R',0,0,
					'A','B','C',0,0,
					'D','E','F',0,0,
					'G','H','I',0,0
				};


	text_flags=0-text_flags;
	template=0;

	set_text_cursor_height();
	if(max<0 || max>512)
	{
		template=max;
		max=strlen(max);
	}

	txt[max]=0;
	cursor_width(1);
	x=get_cursor();

	if( template && *template=='~' && (*txt==0) )
	{
		print_string(template+1);
		cursor(x);
		update_screen();
		getch();
		ungetch();
		template=0;
	}

	if( template && (*txt==0) )
	{
		key=0;
		n=0;
		while( template[n] )
		{
			if( template[n]!='@' && template[n]!='#' )
			{
				txt[n]=template[n];
				key=1;
			}
			else
			{
				txt[n]=' ';
			}
			n++;
		}
		txt[n]=0;
		if(!key)
		{
			*txt=0;
		}
	}

	memset( read_cpu_register32(CPU_DX),space_in_text,max );
	print_string(txt);
	cursor(x);

	if(drawing_form)
	{
		return(0);
	}

	
#IF tag_type TagIt ;	
int *tag;
	if((text_flags & 1048576) && (text_flags & 8) )
	{		
		memset(temp_string,0,10);
		do
		{					
			beep(10,10);
		}while (sensech()==0 && tag_read_block(1,&n,temp_string)==0);
		
		if(sensech()==0)
		{
			tag=temp_string+1;
			itoa(*tag,txt,10);	
			print_string(txt);
			beep(300,100);
			return(13);
		}
	}	
#ENDIF ;

	n=0;	
// --------------------- Process the initial key ---------------------------
	switch(sensech())
	{
		case 13:
				getch();
				return(DOWN);
		case DOWN:
		case UP:
		case 27:
				getch();
				break;
		case RIGHT:
				getch();
				lcd_cursor=read_cpu_register32(CPU_DX)-display_ram-display_address_func_set_display;
				lcd_cursor_column=lcd_cursor%display_width;
				lcd_cursor_line=read_cpu_register32(CPU_REG4);
				n=strlen(txt);
				if( (n+lcd_cursor_column)>=lcd_width )
				{
					n=lcd_width-lcd_cursor_column;
				}

				x+=n;
				cursor(x);
				if(txt[n])
				{
					putch(txt[n]);
				}
				break;
		case 8:
		case LEFT:
				getch();
				n=strlen(txt);
				x+=n;
				cursor(x);
				if(txt[n])
				{
					putch(txt[n]);
				}
				break;
	}

	lastkey=0;
	set_display(display_address_func_set_display);
	
	do				/* Main edit loop */
	{
		cursor(x);
		lcd_cursor=read_cpu_register32(CPU_DX)-display_ram-display_address_func_set_display;
		lcd_cursor_column=lcd_cursor%display_width;
		lcd_cursor_line=read_cpu_register32(CPU_REG4);
		p=0;
		v=1;
/*
		for(line=0;line<lcd_cursor_line;line++)
		{
			write_cpu_register32(CPU_SCREENLINE1+4*lcd_cursor_line,read_cpu_register32(CPU_DX)-(lcd_width-1));
			update_screen();
		}
*/
		
		if( template && template[n]!='@' && template[n]!='#' && template[n] )
		{
			if ( n && ( lastkey==LEFT || lastkey==8 ) )
			{
				key=LEFT;
			}
			else
			{
				key=RIGHT;
			}
		}
		else
		{
			update_screen();
			key=getch();
		}

		if(text_flags & 1 )
		{
			if(key==8 || ( key>='0' && key<='z') )
			{
				key=0;
			}	
		}

		lastkey=key;
							// Process control keys
		switch(key)
		{
			case LEFT:
						if(n)
						{
							n--;
							x--;
							cursor(x);
							if(txt[n])
							{
								putch(txt[n]);
							}
						}
						break;
			case 8:
						if(n)
						{
							if( template && template[n-1]!='@' && template[n-1]!='#' && template[n-1] )
							{
								break;
							}
							x--;
							n--;
							cursor(x);
							if(n==strlen(txt)-1)
							{
								putch(space_in_text);
								txt[n]=0;
							}
							else
							{
								putch(txt[n]);
							}
						}
						break;
			case 13:
			case SHIFT_DOWN:
			case SHIFT_UP:
			case DOWN:
			case UP:
			case 27:
						key=0-key;
						break;
			case RIGHT:
						if( n<max && txt[n]!=0 )
						{
							if(txt[n])
							{
								putch(txt[n]);
							}
							n++;
							x++;
							break;
						}
						break;
			default:
						if( ( text_flags & 8 ) || template && template[n]=='#' )
						{
							if( !isdigit(key) && key!='.' && key!=' ' )
							{
								key=0;
							}
						}
						if(key)
						{
							if(n<max)
							{
								if(txt[n]==0)
								{
									txt[n+1]=0;
								}
								txt[n]=key;
								if( text_flags&4 )
								{
									putch('*');
								}
								else
								{
									putch(key);
									if(last_key_scancode>256)
									{
										if( ( !template || template[n]!='#' ) && ( text_flags & 8)==0  )
										{
											cursor(get_cursor()-1);
											update_screen();
											keytimer=0;
											keylistptr=0;
											do
											{
												if(sensech())
												{
													if(sensech()!=key)
													{
														break;
													}
													else
													{
														getch();
														if(keylist[key-'.'][keylistptr])
														{
															txt[n]=keylist[key-'.'][keylistptr];
															keylistptr++;
														}
														else
														{
															txt[n]=key;
															keylistptr=0;
														}
														if( (text_flags&4)==0 )
														{
															putch(txt[n]);
															cursor(get_cursor()-1);
															update_screen();
														}
														keytimer=0;
													}
												}
												keytimer++;
											}
											while(keytimer<300);
											cursor(get_cursor()+1);
											update_screen();
										}
									}
								}
								n++;
								x++;
							}
							else
							{
								if(text_flags & 2)
								{
									ungetch();
									key= -DOWN;
									break;
								}
							}
						}
		}
	}
	while(key>=0);
	cursor(x-n);
#IFNOT system_type ponto ;
	set_function_keys("",1);
#ENDIF ;
	set_display(display_address_func_set_display);
	return(0-key);
}
#ENDIF ;

// --------------------- Time and Date -------------------------------------

char os_week[2][7][10]={
			"Segunda  ",
			"Terca    ",
			"Quarta   ",
			"Quinta   ",
			"Sexta    ",
			"Sabado   ",
			"Domingo  ",
			"Lunes    ",
			"Martes   ",
			"Miercoles",
			"Jueves   ",
			"Viernes  ",
			"Sabado   ",
			"Domingo  "
		 };

/*

          		"Montag   ", 
          		"Dienstag ", 
          		"Mittwoch ", 
          		"Donnerst.", 
          		"Freitag  ", 
          		"Samstag  ", 
          		"Sonntag  ",

		"Monday   ",
		"Tuesday  ",
		"Wednesday",
		"Thursday ",
		"Friday   ",
		"Saturday ",
		"Sunday   ",

           		"Lundi    ", 
           		"Mardi    ", 
           		"Mercredi ", 
           		"Jeudi    ", 
           		"Vendredi ", 
           		"Samedi   ", 
           		"Dimanche ", 
*/

char time_string[10];
char date_string[30];
int time_seconds;
int date_days;

get_seconds()
{
	int absolute_time_seconds;
	absolute_time_seconds_quartz=read_cpu_register32_verified(CPU_SECONDS_COUNTER);
	absolute_time_seconds=absolute_time_seconds_start+absolute_time_seconds_quartz;
	if(absolute_time_seconds_adjust)
	{
		absolute_time_seconds=absolute_time_seconds+absolute_time_seconds_quartz/absolute_time_seconds_adjust;
	}
	return(absolute_time_seconds);
}

#IF compile_timing_functions  1 ;
get_time()
{
	get_seconds();
	return(get_time2());
}

get_time2()
{
	time_seconds=absolute_time_seconds_func_get_seconds%86400;
	date_days=read_cpu_register32(CPU_REG4);
	timetoa(time_seconds,time_string);
	datetoa(date_days,date_string);
	return(absolute_time_seconds_func_get_seconds);
}
#ENDIF;

#IF compile_timing_functions  1 ;
set_time()
{
	int s;
	time_seconds=atotime(time_string);
	date_days=atodate(date_string);
	if( (time_seconds!=-1) && (date_days!=-1) && (date_days<36500) )
	{
		s=time_seconds+86400*date_days;
		set_seconds(s);
		return(s);
	}
	return(-1);
}
#ENDIF;

// --------------------- 16c71 - Time --------------------------------------

read_cpu_register32_verified(int address)
{
	int n;
	do
	{
		n=read_cpu_register32(address);
	}
	while(n!=read_cpu_register32(address));
	return(n);
}

write_cpu_register32_verified(int address,int n)
{
	do
	{
		write_cpu_register32(address,n);
	}
	while(n!=read_cpu_register32(address));
}

#IF system_type ponto ;
set_seconds(int t)
{
	absolute_time_seconds_start=t;
	do
	{
		write_cpu_register32_verified(CPU_SECONDS_COUNTER,0);
		write_cpu_register32_verified(CPU_SECONDS_COUNTER2,0);
	}
	while( read_cpu_register32_verified(CPU_SECONDS_COUNTER) != 0 || read_cpu_register32_verified(CPU_SECONDS_COUNTER2) != 0 );
	power_off_countdown_restart();
}

#ELSE ;

//int last_absolute_time_seconds_start;

set_seconds(int t)
{
	absolute_time_seconds_quartz=read_cpu_register32_verified(CPU_SECONDS_COUNTER);

	absolute_time_seconds_start=t-absolute_time_seconds_quartz;

	if(absolute_time_seconds_adjust)
	{
		absolute_time_seconds_start-=(absolute_time_seconds_quartz/absolute_time_seconds_adjust);
	}
	
}
#ENDIF ;

// --------------------- Time and Date Conversion -------------------------------------
#IF compile_timing_functions  1 ;

#define os_start_year 1996
#define os_week_adjust 0
int os_month_days[2][12]={
				0,
				31,
				59,
				90,
				120,
				151,
				181,
				212,
				243,
				273,
				304,
				334,
				0,
				31,
				60,
				91,
				121,
				152,
				182,
				213,
				244,
				274,
				305,
				335
			};

datetoa(int days,char *time_string_temp)
{
	int d,m,y,y4;
	
	d=days%(1461);
	y=4*read_cpu_register32(CPU_REG4);

	if(d>=1096)
	{
		d-=1096;
		y4=3;
	}
	else
	{
		if(d>=731)
		{
			d-=731;
			y4=2;
		}
		else
		{
			if(d>=366)
			{
				d-=366;
				y4=1;
			}
			else
			{
				y4=0;
			}
		}
	}

	for(m=11;m>=0;m--)
	{
		if( d >= os_month_days[y4==0][m] )
		{
			d-=os_month_days[y4==0][m];
			break;
		}
	}
	m++;
	d++;
	y+=y4;

	itoa00(d,time_string_temp);

	time_string_temp[2]='/';

	itoa00(m,time_string_temp+3);

	time_string_temp[5]='/';

	//itoa((y+os_start_year)%100,time_string_temp+6,10);
	itoa((y+os_start_year),time_string_temp+6,10);

	days=(days+os_week_adjust)%7;
	strcpy(time_string_temp+11,os_week[os_language][days]);
	return(time_string_temp);
}

atodate(char *t)
{
	int d,m,y;
	while( *t && !isdigit(*t))
	{
		t++;
	}
	if(*t)
	{
		d=atoi(t);
	}
	else
	{
		return(0-1);
	}
	while( *t && isdigit(*t))
	{
		t++;
	}
	while( *t && !isdigit(*t))
	{
		t++;
	}
	if(*t)
	{
		m=atoi(t);
	}
	else
	{
		return(0-1);
	}
	while( *t && isdigit(*t))
	{
		t++;
	}
	while( *t && !isdigit(*t))
	{
		t++;
	}
	if(*t)
	{
		y=atoi(t);
		if(y>5000)
		{
			y=y/100;
		}
		if(y>99)
		{
			y=y-os_start_year;
		}
		else
		{
			y=y-os_start_year+1900;
		}
		if(y<0)
		{
			return(0-1);
		}
	}
	else
	{
		return(0-1);
	}
	return(atodate2(d,m,y));
}

int atodate2(int d,int m,int y)
{
	int days;
	days=365*y+(y+3)/4;
	if(m>2)
	{
		if(4*(y/4)==y)
		{
			days++;
		}
	}
	switch(m)
	{
		case 1:	if(d>31)
				{
					return(0-1);
				}
				break;
		case 2:	if(4*(y/4)==y)
				{
					if(d>29)
					{
						return(0-1);
					}
				}
				else
				{
					if(d>28)
					{
						return(0-1);
					}
				}
				days+=31;
				break;
		case 3:	if(d>31)
				{
					return(0-1);
				}
				days+=59;
				break;
		case 4:	if(d>30)
				{
					return(0-1);
				}
				days+=90;
				break;
		case 5:	if(d>31)
				{
					return(0-1);
				}
				days+=120;
				break;
		case 6:	if(d>30)
				{
					return(0-1);
				}
				days+=151;
				break;
		case 7:	if(d>31)
				{
					return(0-1);
				}
				days+=181;
				break;
		case 8:	if(d>31)
				{
					return(0-1);
				}
				days+=212;
				break;
		case 9:	if(d>30)
				{
					return(0-1);
				}
				days+=243;
				break;
		case 10:	if(d>31)
				{
					return(0-1);
				}
				days+=273;
				break;
		case 11:	if(d>30)
				{
					return(0-1);
				}
				days+=304;
				break;
		case 12:	if(d>31)
				{
					return(0-1);
				}
				days+=334;
				break;
			default:
				return(0-1);
	}
	days=days+d-1;
	return(days);
}

int timetoa(int n,char *time_string_temp)
{
	int h,m,s;
	h=n/3600;
	m=(n%3600)/60;
	s=(n%3600)%60;
	time_string_temp[0]='0'+h/10;
	time_string_temp[1]='0'+h%10;
	time_string_temp[2]=':';
	time_string_temp[3]='0'+m/10;
	time_string_temp[4]='0'+m%10;
	time_string_temp[5]=':';
	time_string_temp[6]='0'+s/10;
	time_string_temp[7]='0'+s%10;
	time_string_temp[8]=0;
	return(time_string_temp);
}

atotime(char *t)
{
	int h,m,s;
	h=atoi(t);
	while( *t && isdigit(*t))
	{
		t++;
	}
	if(*t)
	{
		t++;
	}
	m=atoi(t);
	while( *t && isdigit(*t))
	{
		t++;
	}
	if(*t)
	{
		t++;
	}
	s=atoi(t);
	if( h>=24 || m>=60 || s>=60 )
	{
		return(0-1);
	}
	return(60*(60*h+m)+s);
}
#ENDIF ;
// --------------------- Some C functions in C -----------------------------

public int isdigit(int a)
{
	if( a>='0' && a<='9' )
	{
		return(1);
	}
	return(0);
}

isalpha(int a)
{
	int b;
	b=a|32;
	if( b>='a' && b<='z' )
	{
		return(1);
	}
	if( a==' ' || a=='.')
	{
	 	return(1);
	}
	return(0);
}

isalnum(int a)
{
	if(isdigit(a))
	{
		return(1);
	}
	return(isalpha(a));
}

// --------------------- Keyboard input functions --------------------------

set_text_cursor_height()
{
#IFNOT software_type xrt100c ;
	if( caps_lock )
	{
		cursor_height(255);
	}
	else
	{
		cursor_height(128);
	}
#ELSE ;
	cursor_height(128);
#ENDIF ;
}

public int new_text(char *txt,int max,int text_flags)
{
	*txt=0;
	return(text(txt,max,text_flags));
}

#IF compile_input_functions 1;
public int numerical_not_less_than(int *x,int n,int min)
{
	push_variable(numerical(x,n,0));
	if( (*x) < min )
	{
		*x=min;
	}
	return(pop_variable());
}
#ENDIF;

public int numerical(int *x,int max_chars,int c)
{
#IF calculator_floats 1 ;
	struct float *f;
#ENDIF ;
	char string[14];
	int last_numerical;

#IF calculator_floats 1 ;
	f=x;
#ENDIF ;

	if( max_chars > 13 )
	{
		max_chars=13;
	}

	if(sensech()=='-')
	{
		*x=0;	
	}

ASM	eeprom32_on ;

#IF calculator_floats 1 ;
	if((0-c)&16777216)
	{
		ftoa(*f,string,decimal_points);
	}
	else
	{
		itoa(*x,string,10);
	}
#ELSE ;
	itoa(*x,string,10);
#ENDIF ;

	if(!(*x))
	{
		*string=0;
	}
ASM	eeprom32_off ;
	
#IFNOT laser_type none ;
		if((0-c) & 64)							// text_flag_Barcode
		{
			max_chars=barcode_text(string,max_chars,c-8);
		}
		else
		{
			max_chars=text(string,max_chars,c-8);
		}
#ENDIF ;

#IF laser_type none ;
			max_chars=text(string,max_chars,c-8);
#ENDIF ;	

ASM	eeprom32_on ;
#IF calculator_floats 1 ;
	if((0-c)&16777216)
	{
		f=x;
		*f=atof(string);
	}
	else
	{
		*x=atoi(string);
	}
#ELSE ;
	*x=atoi(string);
#ENDIF ;
ASM	eeprom32_off ;

	if((0-c)& 65536)
	{
		last_numerical=*x;		
	}
	return(max_chars);
}

#IFNOT software_type TERMINAL ;
#IF compile_input_functions 1;
public new_numerical(int *x,int max_chars,int c)
{
	if( max_chars > 13 )
	{
		max_chars=13;
	}
	max_chars=new_text(string_func_numerical,max_chars,c-8);
#IF calculator_floats 1 ;
	if((0-c)&16777216)
	{
		f_func_numerical=x;
		*f_func_numerical=atof(string_func_numerical);
	}
	else
	{
		*x=atoi(string_func_numerical);
	}
#ELSE ;
	*x=atoi(string_func_numerical);
#ENDIF ;
	return(max_chars);
}
#ENDIF ;
#ENDIF;

// -------------------------------------------------------------------------

itoa00(int n,char *t)
{
	if(n<10)
	{
		*t='0';
		t++;
	}
	return(itoa(n,t,10));
}


// -------------------------------------------------------------------------

print_short_string(char *txt1,int size)
{
#IFNOT system_type ponto ;
#IFNOT software_type RADIOBASE ;
	int *ptr1;
	int *size1;
	int *size2;
	int n;
	int nn;
	char *ptr;
	char *s;
	int recsize;
	int extrasize;
	//char *dcursor;
	ptr1=system_form+number_of_form_lines-number_of_os_menu_lines-1;
	size1=ptr1+50;
	size2=ptr1+100;
	ptr=txt1;
	nn=0;
loop1:
	ptr1[nn]=ptr;
	if( s=strchr(ptr,' ') )
	{
		s++;
		size1[nn]=s-ptr;
		ptr=s;
		nn++;
		goto loop1;
	}
	else
	{
		size1[nn]=strlen(ptr);
		nn++;
	}
	recsize=size/nn;
	extrasize=size-recsize*nn;
	for(n=0;n<nn;n++)
	{
		if(size1[n]>recsize)
		{
			if(extrasize)
			{
				size2[n]=recsize+1;
				extrasize--;
			}
			else
			{
				size2[n]=recsize;
			}
		}
		else
		{
			extrasize+=recsize-(size2[n]=size1[n]);
		}
	}
	n=0;
	while(extrasize)
	{
		if(size1[n]>size2[n])
		{
			size2[n]++;
			extrasize--;
		}
		n++;
		if(n>=nn)
		{
			n=0;
		}
	}
	ptr=read_cpu_register32(CPU_DX);
	for(n=0;n<nn;n++)
	{
		memcpy(ptr,ptr1[n],size2[n]);
		ptr=read_cpu_register32(CPU_BX);
		if(size2[n]<size1[n])
		{
			*(ptr-1)='.';
		}
	}
	cursor(get_cursor()+size);
#ENDIF ;
#ENDIF ;
}

// -------------------------------------------------------------------------
#define  DIGITNUMBER                 123456789

#IF laser_type none ;
public int barcode_text(char *txt,int max_aux,int text_flags)
{
}
public int new_barcode_text(char *txt,int max,char *template)
{
}
#ENDIF ;

#IFNOT laser_type none ;

int print_string_password(char *txt)
{
	memset(read_cpu_register32(CPU_DX),'*',strlen(txt));
	write_cpu_register32(CPU_DX,read_cpu_register32(CPU_DX)+strlen(txt));		
}

public int enable_barcode_with_any_key;
barcode_text(char *txt,int max_aux,int text_flags)
{
	int c,pos,pos2;
	int input_result;
	int max;
	char *template;
	int must_wait_for_release;
	int manual;
	int min_barcode_size;
	int last_key;
	int returnkey;

	push_variable(getch_waits_for_serie);
	getch_waits_for_serie=0;

	manual=0;
	text_flags=0-text_flags;

	max=max_aux;
	if(max>512)
	{
		template=max;
		max=strlen(max);
	}
	else
	{
		template=0;
	}

	pos=get_cursor();
	pos2=pos;
	
	memset(display_ram+pos,space_in_text,max);

	if(text_flags&1024)
	{
		cursor(pos+max-strlen(txt));
		print_string(txt);
	}
	else
	{
		if(text_flags&4)
		{
			print_string_password(txt);
		}
		else
		{			
			print_string(txt);
		}
		cursor(pos);
	}

	if(drawing_form)
	{
		text(txt,max_aux,0-text_flags);
		getch_waits_for_serie=pop_variable();
		return(0);
	}

	set_text_cursor_height();

	if(*buffer_func_laser_flush)
	{
		returnkey=TAB;
		if( strlen(buffer_func_laser_flush) <= max )
		{
			strcpy(txt,buffer_func_laser_flush);
			*buffer_func_laser_flush=0;
			flush_keyboard_buffer();
			if(text_flags&16)
			{
				returnkey=26;
			}
		}
		else
		{
			memcpy(txt,buffer_func_laser_flush,max);
			txt[max]=0;
			strcpy(buffer_func_laser_flush,buffer_func_laser_flush+max);
		}
		
		print_string(txt);
		if( (text_flags&2 ) == 0 && (text_flags&16384 ) == 0)
		{
			*buffer_func_laser_flush=0;
			while(inkey())
			{
				correct_16c71_reset();
			}
			flush_keyboard_buffer();
		}

		getch_waits_for_serie=pop_variable();
		return(returnkey);
	}

	do
	{
		//voltage_func_power_off_countdown=battery_voltage();
		power_off_countdown_restart();
		power_off_countdown();

		cursor(pos);
		c=getch();

		if( ( c>='0'&&c<='9'  || c=='.') )
		{
			if(enable_barcode_with_any_key)
			{
				c=RIGHT;
			}
			else
			{
				last_key=c;
				c=DIGITNUMBER;	
			}				
		}

		if(enable_barcode_with_any_key>1)
		{
			c=RIGHT;
		}

		switch(c)
		{
			case ENTER:
			case RIGHT:
read_barcode:
					if( set_external_keyboard_power(1) == 0 )
					{
						beep(200,200);
						set_external_keyboard_power(0);
						getch_waits_for_serie=pop_variable();
						return(0);
					}

					memset(txt,' ',max);
					txt[max]=0;

					must_wait_for_release=1;

					flush_keyboard_buffer();
					input_result = fast_new_text(txt,max,(laser_on_time+2)/3);
					flush_keyboard_buffer();
					
					laser_flush();
					set_external_keyboard_power(0);
					write_cpu_register32(CPU_COM_TIMEOUT,5000);
					laser_read_byte();
					
					if(!check_template(txt,template))
					{
						*buffer_func_laser_flush=0;
						memset(txt,' ',max);
						txt[0]=0;
						input_result=0;

						if((text_flags&32768))
						{
							c=getch();
							goto read_barcode;
						}
					}

					if(inkey()==0)
					{
						must_wait_for_release=0;
					}

					if(input_result)
					{
/*
						Substitui a virgula por ponto
						if( text_flags & 8)
						{
							char *temp_p;
							temp_p=strchr(txt,',');
							if(temp_p>0)
							{
								*(temp_p)='.';
							}
						}
*/						
						barcode_beep();
						memset(display_ram+pos,space_in_text,max);
						if( text_flags & 1024)
						{
							cursor(pos+max-strlen(txt));
						}
						else
						{
							cursor(pos);
						}
				
						if(text_flags&4)
						{							
							print_string_password(txt);							
						}
						else
						{
							print_string(txt);
						}
						
						if( (text_flags&2 ) == 0 && (text_flags&16384 ) == 0)
						{
							*buffer_func_laser_flush=0;
							if(must_wait_for_release)
							{
								while(sensech())
								{
									while(inkey())
									{
										correct_16c71_reset();
									}
									getch();
								}
							}
							else
							{
								flush_keyboard_buffer();
							}
						}
						print_string("                    ");
						if(text_flags&16)
						{
							getch_waits_for_serie=pop_variable();
							return(27);
						}
						getch_waits_for_serie=pop_variable();
//						if( strlen(buffer_func_laser_flush) > max )
						if( strlen(buffer_func_laser_flush) )
						{
							keyboard_unread_from_buffer(ENTER,0);
						}
						return(TAB);
					}
					getch_waits_for_serie=pop_variable();
					return(0);
					break;
			case DIGITNUMBER:
					if( (text_flags & 2097152) ==0 )			// Don't accept Keyboard
					{
						keyboard_unread_from_buffer(last_key,0);
						getch_waits_for_serie=pop_variable();
						manual=1;					
						return(text(txt,max_aux,0-text_flags));
					}	
					break;
			case LEFT:
					if( (text_flags & 2097152) ==0 )			// Don't accept Keyboard
					{						
						getch_waits_for_serie=pop_variable();
						manual=1;					
						return(text(txt,max_aux,0-text_flags));
					}	
					break;
			default:
					getch_waits_for_serie=pop_variable();			
					return(0-c);
					break;
		}
	}
	while(1);
}

#ENDIF ;

#IF system_type vertical ;
#IFNOT laser_type none ;
fast_new_text(char *txt,int n,int timeout)
{
	char *txt2;
	int c;
	// int exit_time;
	int tt;

	timeout=1300;

	// exit_time=get_seconds()+20;
	txt2=txt;
	while(n)
	{
		c=timeout;
		do
		{
			/*
			if(get_seconds()>=exit_time)
			{
				*txt=0;
				write_cpu_register(CPU_BASIC_FLAGS,65280+1);		// Enable internal keyboard
				return(0);
			}
			*/
			write_cpu_register(CPU_BASIC_FLAGS,65280-256);			// Disable Internal Keyboard
			if(c)
			{
				c--;
				if(c==0)
				{
					write_cpu_register(CPU_BASIC_FLAGS,65280+1);	// Enable internal keyboard
					if(upside_down)
					{
						if( inkey()==265 )						// LEFT
						{
							c=timeout;
						}
					}
					else
					{
						if(enable_barcode_with_any_key)
						{
							if( ( inkey()>=274 && inkey()<=297 ) || inkey()==307 )	// LEFT 1 2 3 4 5 6 7 8 ENTER
							{
								c=timeout;
							}
						}
						else
						{
							if( inkey()==275 )					// RIGHT
							{
								c=timeout;
							}
						}
					}
					if( c==0 )
					{
						if(timeout)
						{
							*txt=0;
							return(0);
						}
					}
					set_external_keyboard_power(0);
					set_external_keyboard_power(1);
					write_cpu_register(CPU_BASIC_FLAGS,65280-256);	// Disable Internal Keyboard
				}
			}
		}
		while(kbhit()!=2);

		c=lastkeypressed_func_sensech2;

		flush_keyboard_buffer();
		tt=50;
		do
		{
			if(c)
			{
				tt=50;
			}
			else
			{
				tt--;
				if(!tt)
				{
					break;
				}
			}
			if(c==13)
			{
				break;
			}
			*txt2=c;
			txt2++;
			n--;
			if(n==0)
			{
				break;
			}
			
			c=inkey();
		}
		while(1);

		if(c==13)
		{
			if(*txt)
			{
				break;
			}
		}

	}
	*txt2=0;
	write_cpu_register(CPU_BASIC_FLAGS,65280+1);
	
	return(-13);
}
#ENDIF ;

#ELSE ;

fast_new_text(char *txt,int n,int timeout)
{
	char *txt2;
	int c;
	int first;
	txt2=txt;
	first=1;
	while(n)
	{
		c=timeout;
		do
		{
			write_cpu_register(CPU_BASIC_FLAGS,65280-256);		// Disable Internal Keyboard
			if(c)
			{
				c--;
				if(c==0)
				{
					write_cpu_register(CPU_BASIC_FLAGS,65280+1);		// Enable internal keyboard
					if( inkey()==275 )					// RIGHT
					{
						c=timeout;
					}
					if(c==0)
					{
						if(timeout)
						{
							*txt=0;
							return(0);
						}
					}
					write_cpu_register(CPU_BASIC_FLAGS,65280-256);		// Disable Internal Keyboard
				}
			}
		}
		while(kbhit()!=2);
		if(first)
		{
			first=0;
			barcode_beep();
		}
		while(sensech())
		{
			c=getch();
			if(c==13)
			{
				break;
			}
			*txt2=c;
			txt2++;
			n--;
			if(n==0)
			{
				break;
			}
		}
		if( n==0 || c==13 )
		{
			break;
		}
	}
	*txt2=0;
	write_cpu_register(CPU_BASIC_FLAGS,65280+1);
	return(-13);
}
#ENDIF ;

#IFNOT laser_type none ;

check_template(char *txt,char *template)
{
	int n;
	int ch;
	
	if(template==0)
	{
		return(1);
	}

	for(n=0;n<=strlen(template);n++)
	{
		ch=*(txt+n);
		
		switch(*(template+n))
		{
			case '?':
				break;

			case '%':
				if(! isalpha(ch ) )
				{
					return(0);
				}
				break;

			case '@':
				if(! (isdigit(ch) || isalpha(ch) ))
				{
					return(0);
				}
				break;

			case '#':
				if(! isdigit(ch ) && ch!='.' && ch!=' ' && ch!='-')
				{
					return(0);
				}
				break;

			default:
				if(ch!=*(template+n) )
				{
					return(0);
				}
				break;
		}
	}
	return(1);
}

public int new_barcode_text(char *txt,int max,char *template)
{
	*txt=0;
	if(isalnum(sensech()))
	{
		flush_keyboard_buffer();
		return(0);
	}
	return(barcode_text(txt,max,template));
}

barcode_beep()
{
	beep(50,beep_period);
}
#ELSE;
barcode_beep()
{
	beep(50,beep_period);
}
#ENDIF ;


















